\chapter{Benchmark and Dexter}

\section{Benchmark without changes}
First, let us benchmark the queries without any changes, as imported. Each query has been run 6 times. However, the benchmark of the first run is discarded to avoid the problem of a cold start. This results in 5 values from which we take the average to get a real-time measurement. Some of the queries can be found in the appendix.

\section{Improvements with Dexter}
After all of the 113 queries were inserted to Dexter, it found 5 queries to improve. 3b, 12c, and 18b can be improved by adding an index to table movie\_info attribute info. 7a and 7b want an index for table person\_info attribute note. On all other queries, Dexter did not notice any other possible improvements.

Let's add these two indexes. The index movie\_info\_info\_idx is added by Dexter when we add the $--create$ attribute. Unfortunately, the index is invalid. When all columns and indexes of table move\_info are listed, it shows the last, newly added index as 'INVALID'.
\begin{figure}[H]
    \includegraphics[width=\linewidth]{Images/InvalidIndexMovie_info_info.png}
    \caption{Invalid index movie\_info\_info\_idx}
\end{figure}
When we remove the index with \verb|'DROP INDEX movie_info_info_idx;'| and try to add it by ourselves, \verb|'CREATE INDEX movie_info_info_idx on movie_info (info);'|, we get an error: \verb|'ERROR:  index row requires 16536 bytes, maximum size is 8191'|. We could try to avoid this problem when we store the index as a hash, but this index creation goes forever. The handling of such a case can surely be improved in Dexter.\\\\

Next, we add the other proposed index with \verb|'CREATE INDEX person_info_note_idx|\\
\verb|on person_info (note);'|. This time we could successfully inserted the index 'person\_info\_note\_idx' as btree, see last index of person\_info.

\begin{figure}[H]
    \includegraphics[width=\linewidth]{Images/ValidIndexPerson_Info.png}
    \caption{Valid index person\_info\_info\_idx}
\end{figure}

The creation took 12.587 seconds. Now, the query execution time of 7a decreased from $1069.474ms$ to $373.003ms$. So, it is $3$ times faster. And query 7b went from $5694.749ms$ to $88.767ms$. Which is $64$ times faster.

\begin{figure}[H]
    \includegraphics[width=\linewidth]{Images/Graph.png}
    \caption{Comparison of execution times before and after index creation.}
\end{figure}

As stated in the Dexter docs \cite{Dexter},
\textit{Note: Logs or running queries are highly preferred over pg\_stat\_statements, as pg\_stat\_statements often does not store enough information to optimize queries.}
we can get better results when we run the queries when Dexter is logging.

So when we run Dexter in the background and execute all the queries, we should get better suggestions. Let us call Dexter in the worst way with:
\begin{lstlisting}
dexter -h 172.19.0.2 -U postgres postgres --pg-stat-activity
\end{lstlisting}
And indeed, it has not proposed any index.
\section{Simple manual test}
Let us demonstrate and test the functionality of Dexter. We run a query that could be improved with an index. Then we check if Dexter has found that. Therefore we only care for the cast\_info relation. It contains 7 attributes:
\begin{lstlisting}
postgres=# \d cast_info
                                Table "public.cast_info"
     Column     |  Type   | Collation | Nullable |                Default                
----------------+---------+-----------+----------+---------------------------------------
 id             | integer |           | not null | nextval('cast_info_id_seq'::regclass)
 person_id      | integer |           | not null | 
 movie_id       | integer |           | not null | 
 person_role_id | integer |           |          | 
 note           | text    |           |          | 
 nr_order       | integer |           |          | 
 role_id        | integer |           | not null | 
Indexes:
    "cast_info_pkey" PRIMARY KEY, btree (id)
    "cast_info_idx_cid" btree (person_role_id)
    "cast_info_idx_mid" btree (movie_id)
    "cast_info_idx_pid" btree (person_id)
    "cast_info_idx_rid" btree (role_id)
\end{lstlisting}
As we see in the above output we have 5 indexes, including the primary key.\\
There are more than 63 million tuples:
\begin{lstlisting}
postgres=# SELECT COUNT(*) FROM cast_info;
  count   
----------
 63'475'835
(1 row)
\end{lstlisting}

The attribute nr\_order has no index. Let's create a simple query for this column:
\begin{lstlisting}
SELECT * FROM cast_info WHERE nr_order=31;
\end{lstlisting}

70 thousand entries result for this query in 9 seconds:
\begin{lstlisting}
postgres=# EXPLAIN ANALYZE SELECT * FROM cast_info WHERE nr_order=31;
                    QUERY PLAN                  
-----------------------------------------------------------------------------------------
Gather  (cost=1000.00..783263.51 rows=65592 width=41) (actual time=229.994..8752.923 row
    s=70461 loops=1)
Workers Planned: 2
Workers Launched: 2
->  Parallel Seq Scan on cast_info  (cost=0.00..775704.31 rows=27330 width=41) (actual
    time=265.513..8734.687 rows=23487 loops=3)
Filter: (nr_order = 31)
Rows Removed by Filter: 21135125
Planning Time: 0.122 ms
Execution Time: 8763.879 ms
(8 rows)
\end{lstlisting}
Because of the missing index, it uses the parallel sequence scan.
Dexter is running in the background; it has found the improving index. The interval with which Dexter scans the new queries can be set with the parameter '--interval' in seconds.
\begin{lstlisting}
dexter  -h 172.19.0.2  -U postgres  postgres  --pg-stat-activity --interval 10
Started
Processing 1 new query fingerprints
Index found: public.cast_info (nr_order)
\end{lstlisting}
Dexter has passed this simple test.